<template>
  <main>
    <div class="mt-container-small mt-container-padding-bottom-small">
      <div class="columns is-centered">
        <div class="column">
          <mt-page-title
            :link-to="profilLink({ name: 'activites-id', params: { id: activite.id }, query: { visu: visu } })"
            link-text="retour à l’activité"
            :with-border="false"
          >
            <div class="columns">
              <h1 class="has-text-weight-bold is-size-3 column is-narrow">Gérer les participants</h1>
              <div class="column mt-align-right">
                <h1 class="has-text-weight-bold is-size-6">{{ activite.nom }}</h1>
                <mt-date-range-short
                  class="is-uppercase has-text-weight-bold"
                  :start="activite.dateDebut"
                  :end="activite.dateFin"
                />
              </div>
            </div>
          </mt-page-title>
        </div>
      </div>
    </div>
    <mt-list-etapes :etapes="etapes" :etape-selected="etapeSelected" @click="selectEtape" />
    <section class="mt-pax columns is-centered ">
      <mt-box padding="0">
        <div class="column mt-right-bottom">
          <b-button
            class="button mt-button mt-button-fin is-size-8 is-primary has-text-weight-semibold"
            icon-left="download"
            @click="exportCsv"
          >
            <span>Exporter la liste des pax affichés</span>
          </b-button>
        </div>
        <mt-chevron v-if="havePrevious" type="left" :title="previous.nom" @click="previousEtape">
          {{ previous.nom }}
        </mt-chevron>
        <div class="mt-auto-complete-chevron">
          <div>
            <mt-chevron v-if="havePrevious" type="left" is-mobile :title="previous.nom" @click="previousEtape">
            </mt-chevron>
          </div>
          <section class="columns is-mobile is-relative">
            <b-field class="column">
              <b-autocomplete
                class="mt-auto-complete-border-less"
                :data="data"
                placeholder="Rechercher une personne"
                icon="magnify"
                clearable
                :loading="isFetching"
                @typing="getAsyncData"
                @select="selectAutoComplete"
              >
                <template #empty>aucun résultat</template>
                <template #default="{ option }">
                  <article class="columns is-mobile">
                    <div class="column">
                      <mt-utilisateur :utilisateur="option.utilisateur" />
                    </div>
                    <div class="column is-narrow">
                      <span class="mt-statut">{{ option.statut.nom }}</span>
                    </div>
                  </article>
                </template>
              </b-autocomplete>
            </b-field>
            <div class="column is-narrow is-absolute">
              <b-dropdown hoverable>
                <button slot="trigger" class="mt-pax-subscribed-decount">
                  <b-icon icon="account" class="has-text-grey-light" />
                  <b class="mt-pax-subscribed-decount-poucent is-size-7">
                    {{ activite.avancement.taux.nombre }} / {{ activite.avancement.taux.total }}
                  </b>

                  <div class="mt-pax-subscribed-decount-title is-size-7 is-hidden-mobile">
                    {{ activite.avancement.statut.nom }}
                  </div>

                  <b-icon icon="menu-down"></b-icon>
                </button>

                <b-dropdown-item :focusable="false" custom paddingless position="">
                  <article>
                    <mt-progress-pax-sub
                      v-for="(effectif, index) in activite.effectifs"
                      :key="index"
                      class="mt-progress-pax"
                      :pax="effectif"
                      progress-size="5rem"
                    />
                  </article>
                </b-dropdown-item>
              </b-dropdown>
            </div>
          </section>
          <div>
            <mt-chevron v-if="haveNext" type="right" is-mobile :title="next.nom" @click="nextEtape"></mt-chevron>
          </div>
        </div>
        <section class="mt-liste-selected ">
          <b-tag
            v-for="(pax, index) in utilisateurs"
            :key="`env${index}`"
            class="mt-selected"
            closable
            @close="removeSelectedPax(index)"
          >
            {{ pax.utilisateur.nom + ' ' + pax.utilisateur.prenom }}
          </b-tag>
        </section>
        <b-tabs v-model="tabSelected" class="mt-box-onglet mt-box-onglet-big-marge" size="is-small">
          <template v-for="(etapeStatut, index) in etapeSelected.etapesStatuts">
            <b-tab-item :key="index" :label="`${etapeStatut.statut.nom} (${etapeStatut.countParticipants})`">
              <mt-filtre-categorie
                :fullsize="participants.fullsize"
                :categories="participants.corps"
                :groupes="groupes"
                :groupe-selected="groupeSelected"
                @select-all="unfiltreCategorie"
                @select-categorie="filtreCategorie"
                @select-groupe="filtrerGroupe"
                @unselect-groupe="unfiltrerGroupe"
              >
                <template v-if="participants.filtrer.length > 0">
                  <mt-checkbox-all :etat="etatCheckbox" :disabled="noAction" @click="selectionnerAll" />
                  <template v-if="utilisateurs.length > 0">
                    <template v-for="(choixEtapeStatuts, index2) in etapeStatutSelected.choixEtapeStatuts">
                      <b-button
                        :key="`choix${index2}`"
                        type="is-text"
                        :icon-left="calculerIcone(choixEtapeStatuts.choix)"
                        :title="choixEtapeStatuts.choix.nom"
                        @click="choisirSelectionner(choixEtapeStatuts.choix)"
                      >
                      </b-button>
                    </template>
                  </template>
                </template>
              </mt-filtre-categorie>
              <mt-list v-slot="{ item: filtre }" :list="participants.filtrer">
                <mt-list-item
                  :name="`utilisateur-${utilisateur.id}`"
                  :row-class="isSelected(filtre)"
                  class="mt-participants"
                >
                  <b-checkbox
                    v-model="utilisateurs"
                    :native-value="filtre"
                    :disabled="noAction"
                    :name="`b-utilisateur-${utilisateur.id}`"
                  ></b-checkbox>
                  <span class="mt-nom-prenom"
                    ><mt-utilisateur :utilisateur="filtre.utilisateur"/> <mt-choix-mark :choix="filtre.choix"
                  /></span>
                  <span
                    v-if="filtre.dateValidation && filtre.choix.code == 'candidater'"
                    class="mt-date-candidat is-hidden-mobile"
                    title="date de candidature"
                    >{{ dateFormatter(filtre.dateValidation) }}</span
                  >
                  <div class="action-buttons">
                    <template v-for="(choixEtapeStatuts, index2) in etapeStatutSelected.choixEtapeStatuts">
                      <b-button
                        v-if="!etatCheckbox.checked && !etatCheckbox.indeterminate"
                        :key="`choix${index2}`"
                        type="is-text"
                        class="mt-button-action-on-hover"
                        :icon-left="calculerIcone(choixEtapeStatuts.choix)"
                        :title="choixEtapeStatuts.choix.nom"
                        @click="choisir(filtre, choixEtapeStatuts.choix)"
                      >
                      </b-button>
                    </template>
                    <span v-if="filtre.autresActivites != null" class="mt-nb-activite">{{
                      nbAutresActivites(filtre)
                    }}</span>
                    <b-button
                      v-if="filtre.autresActivites != null"
                      :key="`autresActivites${index}`"
                      type="is-text"
                      icon-left="clipboard-alert"
                      title="Autres activités auxquelles il est susceptible de participer"
                      @click="openAutresActivites(filtre)"
                    >
                    </b-button>
                    <b-button
                      v-if="filtre.commentaires != null"
                      :key="index"
                      type="is-text"
                      icon-left="message-reply-text"
                      title="Consulter l'historique des messages"
                      @click="openHistoriqueCommentaire(filtre)"
                    >
                    </b-button>
                  </div>
                </mt-list-item>
              </mt-list>
            </b-tab-item>
          </template>
        </b-tabs>
        <mt-chevron v-if="haveNext" type="right" :title="next.nom" @click="nextEtape">{{ next.nom }}</mt-chevron>
      </mt-box>
    </section>

    <mt-modal-action
      v-if="indisponibilite.length === 0"
      :ouvert.sync="commentaireOpen"
      :b-action="choixNom"
      message-expanded
      @action="activerChoix"
    >
      Êtes-vous certain(e) de vouloir confirmer votre action ?<br />
      <p v-if="utilisateurs.length > 1">
        Les <b>{{ utilisateurs.length }}</b> participants seront informés de votre décision.
      </p>
      <p v-else>
        Le participant sera informé de votre décision.
      </p>

      <mt-commentaire
        v-for="(commentaireEmploye, index) in commentairesEmploye"
        :key="`commentaire${index}`"
        is-fil-de-discustion
        :commentaire="commentaireEmploye"
        :redacteur="commentaireEmploye.redacteur"
      />

      <br />
      <div v-if="indisponibilite.length === 0" class="columns is-mobile is-4 is-variable">
        <div class="column is-narrow">
          <mt-pastille v-if="utilisateur" is-blue>{{ utilisateur.initial }}</mt-pastille>
        </div>
        <div class="column">
          <b-field label="commentaire (facultatif)">
            <b-input
              v-model="commentaire"
              maxlength="300"
              type="textarea"
              placeholder="Ajoutez un commentaire."
              has-counter
            ></b-input>
          </b-field>
          <mt-message-info v-if="utilisateurs.length > 1"
            >Ce commentaire sera envoyé à toutes les personnes selectionnées</mt-message-info
          >
        </div>
      </div>
    </mt-modal-action>
    <mt-modal-ok v-else :ouvert.sync="commentaireOpen">
      <article class="columns is-mobile">
        <p class="column is-narrow">
          <mt-utilisateur :utilisateur="participer.selectionnees[0].utilisateur"></mt-utilisateur>
        </p>
        <p class="column is-narrow">
          participe déjà une autre activité.
        </p>
      </article>
    </mt-modal-ok>
    <mt-modal :ouvert.sync="commentaireHistoriqueOpen">
      <div class="mt-commentaires ">
        <mt-commentaire
          v-for="(commentaireItem, index) in commentaires"
          :key="`commentaire${index}`"
          is-fil-de-discustion
          :redacteur="commentaireItem.redacteur"
          :commentaire="commentaireItem"
        />
      </div>
      <mt-message-info v-if="commentaires.length === 0">Aucun commentaire</mt-message-info>
    </mt-modal>
    <mt-modal :ouvert.sync="autresActivitesOpen" :size="900">
      <mt-list v-slot="{ item: activite }" :list="autresActivites">
        <mt-list-item :row-class="resolveTypeActivite(activite, 'mt-list-item-no-table').class">
          <article class="columns is-vcentered ">
            <div class="column no-wrap">
              <nuxt-link :to="profilLink({ name: 'activites-id', params: { id: activite.id } })">
                <mt-date-range-short
                  class="is-uppercase has-text-weight-bold"
                  :start="new Date(activite.dateDebut)"
                  :end="new Date(activite.dateFin)"
                />
              </nuxt-link>
            </div>
            <div class="column is-one-third">
              <nuxt-link :to="profilLink({ name: 'activites-id', params: { id: activite.id } })">
                {{ activite.nom }}
              </nuxt-link>
            </div>
            <div class="column columns is-centered no-wrap">
              <nuxt-link :to="profilLink({ name: 'activites-id', params: { id: activite.id } })">
                <span class="mt-statut">{{ statut(activite.participants[0]) }}</span>
              </nuxt-link>
            </div>
            <div class="column no-wrap is-2">
              <nuxt-link :to="profilLink({ name: 'activites-id', params: { id: activite.id } })">
                <mt-progress-activity :activite="activite" />
                <div class="has-text-grey is-size-7">
                  {{ activite.avancement.taux.nombre }} / {{ activite.avancement.taux.total }}
                </div>
              </nuxt-link>
            </div>
          </article>
        </mt-list-item>
      </mt-list>
    </mt-modal>
  </main>
</template>

<script>
import debounce from 'lodash/debounce';
import { DateTime } from 'luxon';
import MtPageTitle from '~/components/base/page-title/index';
import MtBox from '~/components/base/box';
import MtFiltreCategorie from '~/components/filtre/filtre-categorie/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import newParticiper from '~/components/mixins/participerMixin';
import userMixin from '~/components/mixins/userMixin';
import MtChevron from '~/components/base/chevron/index';
import MtModalAction from '~/components/modal/mt-modal-action';
import MtProgressPaxSub from '~/components/activity/progress-pax-subscribed';
import MtListEtapes from '~/components/activity/partipation/liste-etapes';
import MtPastille from '~/components/base/pastille/index';
import MtMessageInfo from '~/components/base/message/mt-message-info';
import MtCommentaire from '~/components/activity/partipation/commentaire';
import MtModal from '~/components/modal/mt-modal';
import MtCheckboxAll from '~/components/base/checkbox-all';
import MtUtilisateur from '~/components/pax/mt-utilisateur';
import newCheckboxAllEtat from '~/components/mixins/checkboxAllMixin';
import MtModalOk from '~/components/modal/mt-modal-ok';
import needVerification from '~/components/mixins/choixMixin';
import { createExportLink, dateFileFormat } from '~/components/mixins/csvMixin';
import MtChoixMark from '~/components/activity/partipation/choix-mark';
import { classResolver } from '~/components/mixins/activityMixin';
import MtDateRangeShort from '~/components/activity/date-range-short';
import MtProgressActivity from '~/components/activity/progress-users-activity';

export default {
  layout: 'sans-container',
  components: {
    MtModalOk,
    MtChoixMark,
    MtCheckboxAll,
    MtModal,
    MtCommentaire,
    MtMessageInfo,
    MtPastille,
    MtListEtapes,
    MtProgressPaxSub,
    MtModalAction,
    MtChevron,
    MtListItem,
    MtList,
    MtFiltreCategorie,
    MtBox,
    MtPageTitle,
    MtUtilisateur,
    MtDateRangeShort,
    MtProgressActivity,
  },
  mixins: [classResolver, userMixin],
  data() {
    return {
      tabSelected: 0,
      utilisateurs: [],
      data: [],
      selected: null,
      isFetching: false,
      choix: null,
      commentaireHistoriqueOpen: false,
      commentaireOpen: false,
      autresActivitesOpen: false,
      participer: null,
      commentaire: '',
      commentaires: [],
      autresActivites: [],
      idCategorieSelected: null,
      groupeSelected: null,
      commentairesEmploye: [],
      indisponibilite: [],
    };
  },
  computed: {
    etatCheckbox() {
      const etat = newCheckboxAllEtat();
      if (this.utilisateurs.length > 0) {
        // eslint-disable-next-line no-restricted-syntax
        for (const participant of this.participants.filtrer) {
          if (!this.utilisateurs.find((value) => value.utilisateur.id === participant.utilisateur.id)) {
            etat.indeterminate = true;
            break;
          }
        }
        if (!etat.indeterminate && this.participants.filtrer.length === this.utilisateurs.length) {
          etat.checked = true;
        }
      }
      return etat;
    },
    havePrevious() {
      return this.previous != null;
    },
    haveNext() {
      return this.next != null;
    },
    choixNom() {
      if (this.choix === null) {
        return '';
      }
      return this.choix.nom.toLowerCase();
    },
    noAction() {
      return this.etapeStatutSelected.choixEtapeStatuts.length === 0;
    },
    idGroupeSelected() {
      if (this.groupeSelected) {
        return this.groupeSelected.id;
      }
      return null;
    },
  },
  watch: {
    tabSelected(value) {
      this.changeEtapesStatuts(value);
    },
    selected(value) {
      this.changeEtapesStatutsRecheche(value);
    },
  },
  async asyncData({ $api, params, query }) {
    const visu = query && query.visu ? query.visu : null;
    const [activite, etapes, groupes] = await Promise.all([
      $api.activites.get(params.id),
      $api.etapes.employeur(),
      $api.utilisateur().groupes(),
    ]);
    const indexEtapeSelected = 0;
    const etapeSelected = etapes[indexEtapeSelected];
    const etapesStatuts = await $api.activites.etapesStatuts(params.id, etapeSelected.id);
    etapeSelected.etapesStatuts = etapesStatuts;
    const etapeStatutSelected = etapesStatuts[0];
    const { participants } = etapeStatutSelected;
    const next = etapes[indexEtapeSelected + 1];
    return {
      participants,
      activite,
      etapes,
      etapeSelected,
      etapeStatutSelected,
      previous: null,
      next,
      indexEtapeSelected,
      groupes,
      visu,
    };
  },
  methods: {
    dateFormatter(date) {
      return DateTime.fromISO(date)
        .setLocale('fr')
        .toFormat('dd/MM/yyyy');
    },
    filtrerGroupe(groupe) {
      this.groupeSelected = groupe;
      this.loadStatus();
    },
    unfiltrerGroupe() {
      this.groupeSelected = null;
      this.loadStatus();
    },
    isActive(etape) {
      return this.etapeSelected.id === etape.id;
    },
    isSelected(participant) {
      if (this.find(participant)) {
        return 'mt-list-item-selected';
      }
      return '';
    },
    find(participant) {
      // ne pas utilisé include, ne marche pas à tous les coup.
      return this.utilisateurs.find((value) => value.utilisateur.id === participant.utilisateur.id);
    },
    selectEtape(index) {
      this.indexEtapeSelected = index;
      this.etapeSelected = this.etapes[this.indexEtapeSelected];
      this.tabSelected = 0;
      this.changeEtapesStatuts(this.tabSelected);
      this.definePreviousNext();
      this.utilisateurs = [];
    },
    definePreviousNext() {
      if (this.indexEtapeSelected > 0) {
        this.previous = this.etapes[this.indexEtapeSelected - 1];
      } else {
        this.previous = null;
      }
      if (this.indexEtapeSelected < this.etapes.length) {
        this.next = this.etapes[this.indexEtapeSelected + 1];
      } else {
        this.next = null;
      }
    },
    previousEtape() {
      if (this.indexEtapeSelected > 0) {
        this.selectEtape(this.indexEtapeSelected - 1);
      }
    },
    nextEtape() {
      if (this.indexEtapeSelected < this.etapes.length) {
        this.selectEtape(this.indexEtapeSelected + 1);
      }
    },
    calculerIcone({ actionPrincipale, actionSuppression }) {
      if (actionPrincipale) {
        return 'account-check';
      }
      if (actionSuppression) {
        return 'backup-restore';
      }
      return 'close';
    },
    changeEtapesStatuts(index) {
      this.etapeStatutSelected = this.etapeSelected.etapesStatuts[index];
      this.refreshEtape();
    },
    async changeEtapesStatutsRecheche(value) {
      if (this.etapeSelected.id !== value.etape.id) {
        this.utilisateurs = [];
      }
      // eslint-disable-next-line no-restricted-syntax
      for (const [index, etape] of this.etapes.entries()) {
        if (etape.id === value.etape.id) {
          this.etapeSelected = etape;
          this.indexEtapeSelected = index;
          break;
        }
      }
      const etapesStatuts = await this.$api.activites.etapesStatuts(
        this.activite.id,
        this.etapeSelected.id,
        this.idGroupeSelected,
      );
      etapesStatuts.forEach((etapeStatut, index) => {
        if (etapeStatut.statut.id === value.statut.id) {
          this.tabSelected = index;
        }
      });
      this.selectedTab(etapesStatuts);
      this.definePreviousNext();
      if (this.participants.filtrer.length > 0) {
        let contient = false;
        for (let i = 0; i < this.utilisateurs.length; i += 1) {
          if (this.utilisateurs[i].utilisateur.id === this.selected.utilisateur.id) {
            contient = true;
          }
        }
        if (!contient) {
          this.utilisateurs.push(
            this.participants.filtrer.find((p) => p.utilisateur.id === this.selected.utilisateur.id),
          );
        }
      }
    },
    unfiltreCategorie() {
      this.idCategorieSelected = null;
      this.loadStatus();
    },
    filtreCategorie(categorie) {
      this.idCategorieSelected = categorie.id;
      this.loadStatus();
    },
    async loadStatus() {
      this.participants = await this.$api.activites.statut(
        this.activite.id,
        this.etapeStatutSelected.statut.id,
        this.idCategorieSelected,
        this.idGroupeSelected,
      );
    },
    async refreshEtape() {
      const etapesStatuts = await this.$api.activites.etapesStatuts(
        this.activite.id,
        this.etapeSelected.id,
        this.idGroupeSelected,
      );
      this.selectedTab(etapesStatuts);
      this.activite = await this.$api.activites.get(this.activite.id);
      this.idCategorieSelected = null;
    },
    selectedTab(etapesStatuts) {
      this.etapeStatutSelected = etapesStatuts[this.tabSelected];
      this.etapeSelected.etapesStatuts = etapesStatuts;
      this.participants = this.etapeStatutSelected.participants;
    },
    async choisir(utilisateurWithComm, choix) {
      this.indisponibilite = [];
      this.choix = choix;
      this.participer = this.getParticiper();
      this.addParticipant(utilisateurWithComm);
      await this.afficherCommentaireEmploye();
      if (this.participer.selectionnees.length === 1 && needVerification(this.choix)) {
        this.indisponibilite = await this.$api.participer.autresActivites(
          this.participer.activite.id,
          this.participer.selectionnees[0].utilisateur.id,
        );
      }
      this.commentaireOpen = true;
    },
    async afficherCommentaireEmploye() {
      this.commentairesEmploye = [];
      if (this.participer.selectionnees.length === 1) {
        this.commentairesEmploye = await this.$api.activites.commentairesDeLemploye(
          this.activite.id,
          this.participer.selectionnees[0].utilisateur.id,
          this.etapeSelected.id,
        );
      }
    },
    async activerChoix() {
      this.ajouterCommentaire();
      try {
        await this.$api.participer.post(this.participer);
        await this.refreshEtape();
        this.participer = null;
        this.commentaireOpen = false;
      } catch ({
        response: {
          data: { message },
        },
      }) {
        this.$buefy.toast.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    ajouterCommentaire() {
      if (this.commentaire && this.commentaire.length > 0) {
        const participants = [];
        this.participer.selectionnees.forEach((participant) => {
          participants.push({
            utilisateur: participant.utilisateur,
            commentaire: this.commentaire,
          });
        });
        this.participer.selectionnees = participants;
        this.commentaire = '';
      }
    },
    choisirSelectionner(choix) {
      this.choix = choix;
      this.commentaireOpen = true;
      this.participer = this.getParticiper();
      this.utilisateurs.forEach((utilisateurWithComm) => {
        this.addParticipant(utilisateurWithComm);
      });
      this.afficherCommentaireEmploye();
      this.utilisateurs = [];
    },
    addParticipant(utilisateurWithComm) {
      this.participer.selectionnees.push({
        utilisateur: utilisateurWithComm.utilisateur,
      });
    },
    getParticiper() {
      const participer = newParticiper();
      participer.activite = this.activite;
      participer.choix = this.choix;
      participer.validateur = this.utilisateur;
      return participer;
    },
    selectionnerAll(value) {
      this.utilisateurs = [];
      if (value) {
        this.participants.filtrer.forEach((participant) => {
          this.utilisateurs.push(participant);
        });
      }
    },
    selectAutoComplete(option) {
      this.selected = option;
    },
    openHistoriqueCommentaire(utilisateurWithComm) {
      this.commentaireHistoriqueOpen = true;
      this.commentaires = utilisateurWithComm.commentaires;
    },
    openAutresActivites(utilisateurWithAutresActivites) {
      this.autresActivitesOpen = true;
      this.autresActivites = utilisateurWithAutresActivites.autresActivites;
    },
    nbAutresActivites(utilisateurWithAct) {
      return utilisateurWithAct.autresActivites.length;
    },
    statut(utilActivite) {
      let ret = utilActivite.dernierAvancement.choix.statut.nomSingulier;
      if (utilActivite.dernierAvancement.choix.statut.code === 'candidats') {
        ret = 'Candidat';
      }
      return ret;
    },
    getAsyncData: debounce(async function getAsyncData(search) {
      this.isFetching = true;
      try {
        if (search != null && search.length > 0) {
          this.data = await this.$api.activites.rechercheParticipants(this.activite.id, search);
        } else {
          this.data = [];
        }
      } catch (e) {
        this.$buefy.toast.open({
          message: 'Une erreur est survenue lors de la récupération des données.',
          type: 'is-danger',
        });
      } finally {
        this.isFetching = false;
      }
    }, 500),
    exportCsv() {
      this.$api.activites
        .exportParticipants(this.activite.id, this.etapeSelected.id, this.idGroupeSelected, this.etapeStatutSelected.id)
        .then((response) => {
          createExportLink(response, this.fileName());
        });
    },
    fileName() {
      return `${dateFileFormat(new Date())}-${this.activite.nom.toLowerCase()}-${
        this.etapeSelected.etapesStatuts[this.tabSelected].statut.code
      }.csv`;
    },
    removeSelectedPax(index) {
      this.utilisateurs.splice(index, 1);
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

.mt-pax {
  --page-size: #{$mt-container-width};
  background-color: $pale-grey-two;
  padding: 2rem 5vw;

  .mt-box {
    max-width: var(--page-size);
    flex-grow: 1;
    min-height: 80vh;
  }
}
.mt-right-bottom {
  margin-top: 1rem;
  margin-right: 1rem;
}
.mt-list-item.mt-participants {
  display: flex;
  align-items: center;
}

.mt-nom-prenom {
  flex-grow: 1;
  display: flex;
  align-items: center;
}
.mt-nb-activite {
  font-size: 0.8rem;
  color: $primary;
  position: relative;
  top: 5px;
  left: 12px;
  z-index: 1;
}
a {
  display: flex;
  align-items: baseline;
}
/deep/ {
  .progress {
    height: 0.5rem;
    width: 50px;
    margin-right: 15px;
  }
  .progress-wrapper:not(:last-child) {
    margin-bottom: 0;
  }
}
/deep/ .mt-filter-liste {
  & > article {
    margin-left: 0.75em;
  }
}
.mt-filter-liste {
  display: flex;
  justify-content: space-between;
  margin-top: 1rem;
  .mt-filter-liste-groupe {
    display: flex;
  }

  /deep/ .mt-filter-item {
    border-radius: 2rem;
    background-color: $pale-grey;
    color: #666ee8;
    font-size: $size-7;
    padding: 0.5em 1em;
    margin: 0 0.25em;

    text-align: center;
    cursor: pointer;
    transition-property: background-color, color;
    transition-duration: 0.3s;

    &.selected,
    &.selected:hover {
      background-color: $periwinkle-blue;
      color: $white;
    }
  }
}
.mt-margin {
  margin: 1rem 2rem;
}

/deep/ .mt-box-onglet .tabs {
  padding-top: 0;
}

.mt-auto-complete-chevron {
  display: grid;
  grid-template-columns: minmax(4vw, 0.12fr) 1fr minmax(4vw, 0.12fr);
  padding: 1rem 0;
  align-items: center;
  grid-gap: 0.5rem;

  /deep/ .field:not(:last-child) {
    margin-bottom: 0;
  }
}
.mt-pax-subscribed-decount {
  display: flex;
  flex-direction: row;
  align-items: center;
  cursor: default;
  border-style: none;
  background-color: transparent;

  .mt-pax-subscribed-decount-poucent {
    color: $grey-dark;
    font-weight: bold;
    padding: 0 0.5rem;
  }
  .mt-pax-subscribed-decount-title {
    color: $grey-dark;
    font-weight: normal;
  }
}
/deep/ .grid-effectif {
  margin-right: 0;
}
.is-relative {
  position: relative;
}
.is-absolute {
  position: absolute;
  right: 0;
  background-color: $white;
}
/deep/ .dropdown-menu {
  left: unset;
  right: 0;
}
/deep/ .field:not(:last-child) {
  margin-bottom: 0;
}
/deep/ a.dropdown-item {
  padding-right: 1rem;
}
/deep/ .mt-statut {
  cursor: pointer;
}
@media screen and (max-width: 768px) {
  .mt-pax {
    padding: 1rem 0;
  }
}

.mt-liste-selected {
  padding: 0 4em;
  align-items: center;
}

.mt-selected {
  background-color: $pale-grey;
  color: #666ee8;
  padding: 0.5em 1em;
  margin: 0.25em;
  font-size: 0.6875rem;
  cursor: default;
}
/deep/ .control.has-icons-left .icon {
  color: $brown-grey;
}
/deep/ .mt-date-range {
  font-size: 0.875rem;
  color: $grey;
}
.mt-date-candidat {
  color: $soft-blue;
  font-size: 0.6875rem;
  padding: 0.3em 1.5em;
  cursor: default;
  text-align: center;
}
.mt-align-right {
  margin: 0.8em 0 0 0;
  text-align: right;
}
</style>
